package com.ldjam.characters;

import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Animation.PlayMode;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.ldjam.game.GdxUtils;
import com.ldjam.game.Item;
import com.ldjam.game.OneRoom;
import com.ldjam.game.Item.ITEM_TYPE;

public class PeasantSoldier extends Peasant{

	public PeasantSoldier(float x, float y) {
		super(x, y);
		speed = 2f;
		Texture texture = GdxUtils.TEXTURE_PEASANT_SOLDIER;
		
		peasentTR = TextureRegion.split(texture, 32, 32);
		walkAnimations[DIRECTION_DOWN] = GdxUtils.loadAnimation(peasentTR, 3, DIRECTION_DOWN, 0.12f);
		walkAnimations[DIRECTION_UP] = GdxUtils.loadAnimation(peasentTR, 3, DIRECTION_UP, 0.12f);
		walkAnimations[DIRECTION_LEFT] = GdxUtils.loadAnimation(peasentTR, 3, DIRECTION_LEFT, 0.12f);
		walkAnimations[DIRECTION_RIGHT] = GdxUtils.loadAnimation(peasentTR, 3, DIRECTION_RIGHT, 0.12f);
		for(int i=0;i<walkAnimations.length;i++){
			walkAnimations[i].setPlayMode(PlayMode.LOOP);
		}

		this.maxLife=3;
		this.life = maxLife;
	}
	
	@Override
	public void loot(OneRoom game){

		double rand = Math.random();
		if(rand>0.4){
			game.getItems().add(new Item(x, y, ITEM_TYPE.SPEED, true));

		}else if(rand > 0.6){
			game.getItems().add(new Item(x, y, ITEM_TYPE.POTION, true));
		}
		game.getItems().add(new Item(x, y, ITEM_TYPE.XP_I, true));
		game.getItems().add(new Item(x, y, ITEM_TYPE.XP_V, true));
		game.getItems().add(new Item(x, y, ITEM_TYPE.XP_I, true));
		game.getItems().add(new Item(x, y, ITEM_TYPE.XP_I, true));
		destroy = true;
	}

	
}
