package com.ldjam.game;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.Input.Keys;

public class Input {

	private int spacePressedSince = 0;
	private boolean newPressSpace=false;
	private int altPressedSince = 0;
	private boolean newPressAlt=false;
	private int escapePressedSince = 0;
	private boolean newPressEscape=false;
	
	public  boolean isKeyUpPressed(){
		return Gdx.input.isKeyPressed(Keys.UP) || Gdx.input.isKeyPressed(Keys.Z) || Gdx.input.isKeyPressed(Keys.W);
	}
	
	public  boolean isKeyDownPressed(){
		return Gdx.input.isKeyPressed(Keys.DOWN) || Gdx.input.isKeyPressed(Keys.S);
	}
	
	public  boolean isKeyLeftPressed(){
		return Gdx.input.isKeyPressed(Keys.LEFT) || Gdx.input.isKeyPressed(Keys.A) || Gdx.input.isKeyPressed(Keys.Q);
	}
	
	public  boolean isKeyRightPressed(){
		return Gdx.input.isKeyPressed(Keys.RIGHT) || Gdx.input.isKeyPressed(Keys.D);
	}
	
	public  boolean isKeySpacePressed(){
		return Gdx.input.isKeyPressed(Keys.SPACE) || Gdx.input.isKeyPressed(Keys.ENTER) || Gdx.input.isKeyPressed(Keys.NUM_1);
	}
	
	public  boolean isKeyAltPressed(){
		return Gdx.input.isKeyPressed(Keys.ALT_LEFT) || Gdx.input.isKeyPressed(Keys.ALT_RIGHT) || Gdx.input.isKeyPressed(Keys.NUM_2) || Gdx.input.isKeyPressed(Keys.BACKSLASH);
	}
	
	public  boolean isKeyEscapePressed(){
		return Gdx.input.isKeyPressed(Keys.ESCAPE) || Gdx.input.isKeyPressed(Keys.NUM_0);
	}
	
	public  boolean isKeySpaceJustPressed(){
		return isKeySpacePressed() && newPressSpace;
	}
	
	public  boolean isKeyAltJustPressed(){
		return isKeyAltPressed() && newPressAlt;
	}
	
	public  boolean isKeyEscapeJustPressed(){
		return isKeyEscapePressed() && newPressEscape;
	}
	
	
	public void update(OneRoom game){
		if(isKeySpacePressed()){
			newPressSpace=(spacePressedSince==0);
			spacePressedSince++;
		}else{
			newPressSpace=false;
			spacePressedSince = 0;
		}
		if(isKeyAltPressed()){
			newPressAlt=(altPressedSince==0);
			altPressedSince++;
		}else{
			newPressAlt=false;
			altPressedSince = 0;
		}
		if(isKeyEscapePressed()){
			newPressEscape=(escapePressedSince==0);
			escapePressedSince++;
		}else{
			newPressEscape=false;
			escapePressedSince = 0;
		}
	}
}
