package com.ldjam.game;

public class Message {

	protected float x,y;
	protected String msg;
	protected float opacity = 0f;
	protected int cptMessage;
	
	public Message(){
		this.x = 0;
		this.y =0;
		this.msg = null;
	}
	
	public void initMessage(float x, float y, String msg){
		this.x = x - (msg.length()*4);
		this.y = y;
		this.msg = msg;
		this.cptMessage = 120;
		opacity=1f;
	}
	
	public void render(OneRoom game){
		if(opacity>0 && msg!=null){
			game.getHud().getFont().setColor(0.1f, 0.1f, 0.1f, opacity);
			game.getHud().getFont().draw(game.getBatch(), msg, x, y);
			game.getHud().getFont().setColor(1f, 1f, 1f, opacity);
			game.getHud().getFont().draw(game.getBatch(), msg, x, y+1);
			game.getHud().getFont().setColor(1f, 1f, 1f, 1f);
		}
	}
	
	public void update(OneRoom game){
		if(cptMessage>0){
			cptMessage--;
		}else if(opacity>0f){
			opacity-=0.02;
			if(opacity<0){
				opacity=0;
				msg=null;
			}
		}
	}
	
	public boolean isActive(){
		return msg!=null && opacity>0;
	}
	
	public void move(float dx, float dy){
		this.x+=dx;
		this.y+=dy;
	}
}
