package com.ldjam.game;

import java.util.List;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.Texture;
import com.badlogic.gdx.graphics.g2d.Animation;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.badlogic.gdx.graphics.g2d.Animation.PlayMode;

public class Room {

	private Texture room, background, fog;
	private int cptFog=0;
	private Animation fireAnimation;
	private float stateTime = 0f;
	
	public Room(){
	
		room = GdxUtils.TEXTURE_ROOM;
		background = GdxUtils.TEXTURE_BACKGROUND;
		fog = GdxUtils.TEXTURE_ROOM_FOG;
		TextureRegion[][] fireRegion = TextureRegion.split(GdxUtils.TEXTURE_FIRE, 96, 32);
		TextureRegion[] frames = new TextureRegion[3];
		frames[0] = fireRegion[0][0];
		frames[1] = fireRegion[1][0];
		frames[2] = fireRegion[2][0];
		fireAnimation = new Animation(0.12f,frames);
		fireAnimation.setPlayMode(PlayMode.LOOP);

	}
	
	public void update(OneRoom game){
		if(cptFog>16){
			cptFog=0;
		}else{
			cptFog++;
		}
	}
	
	public void render(OneRoom game){
		game.getBatch().draw(background, ((game.getPlayer().getX()-320)/4),((game.getPlayer().getY()-176)/8));

		game.getBatch().draw(room, 0,0);
		game.getBatch().draw(fireAnimation.getKeyFrame(stateTime), 272,296);
		stateTime += Gdx.graphics.getDeltaTime(); 

	}
	
	public void renderFront(OneRoom game){
		game.getBatch().draw(cptFog<8?GdxUtils.TEXTURE_ROOM_FOG:GdxUtils.TEXTURE_ROOM_FOG2, 0,0);
	}
	
	
	public boolean isBlocked(List<Point> points, float dx, float dy){
		for (Point point : points) {
			if(isBlocked(point.getX()+dx, point.getY()+dy)){
				return true;
			}
		}
		return false;
	}
	
	public boolean isBlocked(float x, float y){
		if(x<20 || x>620){
			return true;
		}
		
		if(y<32 || y>280){
			return true;
		}
		
		if(y>254 && x>262 && x<374){
			return true;
		}

		
		return false;
	}
	
	public boolean isBlockedRestricted(float x, float y){
		if(x<30 || x>610){
			return true;
		}
		
		if(y<42 || y>270){
			return true;
		}
		
		if(y>244 && x>272 && x<364){
			return true;
		}
		
		
		return false;
	}
}
