package com.ldjam.game;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.ldjam.characters.Personnage;

public class Shoot extends Entity{

	protected float dx, dy, stateTime;
	protected TextureRegion frame;
	protected boolean destroy = false;
	protected int size = 16;
	
	public Shoot(float x, float y, float dx, float dy, TextureRegion frame) {
		super(x, y);
		this.dx = dx;
		this.dy = dy;
		this.frame = frame;
		this.stateTime = 0f;
	}
	

	public void update(OneRoom game){
		x+=dx;
		y+=dy;
		if(game.getRoom().isBlocked(x, y)){
			this.destroy = true;
			GdxUtils.SOUND_ENERGY_HURT_WALL.play();

		}
	}
	
	public void render(OneRoom game){
		if(!destroy){
			game.getBatch().draw(frame, x-(size/2),y-(size/2));
			stateTime += Gdx.graphics.getDeltaTime(); 
		}
	}
	
	public boolean isDestroy(){
		return destroy;
	}
	
	public boolean touchCharacter(OneRoom game){
		for(Personnage perso : game.getPersonnages()){
			if(perso.touchByShoot(game,this)){
				this.destroy = true;
				GdxUtils.SOUND_ENERGY_HURT_GUY.play();
				game.addAnimation(new SimpleAnimation(x-16, y-16, game.getPlayer().getRandomImpactAnimation()));
				return true;
			}
		}
		return false;
	}
	
	public boolean touchPlayer(OneRoom game){
		
		if(game.getPlayer().touchByShoot(game,this)){
			this.destroy = true;
			GdxUtils.SOUND_ENERGY_HURT_GUY.play();
			return true;
		}
		
		return false;
	}
	
	public void setSize(int newSize){
		this.size = newSize;
	}

}
