package com.ldjam.game;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.g2d.Animation;

public class SimpleAnimation extends Entity implements GameAnimation  {

	protected float stateTime;
	protected Animation animation;
	protected int delay = 0;
	
	public SimpleAnimation(float x, float y, Animation animation) {
		super(x, y);
		this.animation = animation;
		this.stateTime = 0f;
	}
	
	public SimpleAnimation(float x, float y, Animation animation, int delay) {
		super(x, y);
		this.animation = animation;
		this.stateTime = 0f;
		this.delay = delay;
	}

	@Override
	public void update(OneRoom game) {
		if(delay==0){
			stateTime += Gdx.graphics.getDeltaTime(); 
		}else{
			delay--;
		}
	}

	@Override
	public void render(OneRoom game) {
		if(delay==0){
			game.getBatch().draw(animation.getKeyFrame(stateTime), x, y);
		}
	}

	@Override
	public boolean isFinish() {
		return delay==0 && animation.isAnimationFinished(stateTime);
	}

}
