package com.ldjam.game;

import com.badlogic.gdx.Gdx;

public class TitleMenu {

	protected boolean activate = true;
	protected int mode = 0;  // 0 = newGame, 1=Quit
	protected float gameOverOpacity=0f;
	protected int cptGameOver=0;
	protected int bestScore=0;
	protected int newScore=0;
	protected String strBestScore="";
	protected String strNewScore="";

	public TitleMenu(){
		activate = true;
	}

	public void render(OneRoom game){
		game.getBatch().draw(GdxUtils.TEXTURE_TITLE_BG, 0, 0);
		game.getBatch().draw(mode==0?GdxUtils.TEXTURE_TITLE_NEW_GAME:GdxUtils.TEXTURE_TITLE_QUIT, 410, 38);
		if(strBestScore != null && !strBestScore.isEmpty()){
			game.getBatch().draw(GdxUtils.TEXTURE_SKULL, 8, 16);

			game.getHud().getFont().setColor(0,0,0,1);
			game.getHud().getFont().draw(game.getBatch(),strBestScore,32,32);
			game.getHud().getFont().setColor(0.8f,0.8f,0.8f,1);
			game.getHud().getFont().draw(game.getBatch(),strBestScore,32,33);
			game.getHud().getFont().setColor(1,1,1,1);

		}
	}

	public void renderGameOver(OneRoom game){
		if(gameOverOpacity>=0){
			game.getBatch().setColor(1, 1, 1, gameOverOpacity);
			game.getBatch().draw(GdxUtils.TEXTURE_GAMEOVER, 0,0);
			game.getBatch().draw(GdxUtils.TEXTURE_SKULL, 8, 16);
			game.getHud().getFont().setColor(0.8f,0.8f,0.8f,1);
			game.getHud().getFont().draw(game.getBatch(),strNewScore,32,32);
			game.getBatch().setColor(1, 1, 1, 1);
		}
	}

	public void updateGameOver(OneRoom game){
		if(gameOverOpacity<1f){
			gameOverOpacity+=0.01f;
			if(gameOverOpacity>1f){
				gameOverOpacity=1f;
			}
		}else if(cptGameOver<200){
			cptGameOver++;
		}else{
			game.initGame();
			activate=true;
			mode=0;
		}
	}

	public void update(OneRoom game){
		if(game.getInput().isKeyDownPressed() && mode==0){
			mode = 1;
			GdxUtils.SOUND_DIALBOX_SELEC.play();
		}else if(game.getInput().isKeyUpPressed() && mode==1){
			mode = 0;
			GdxUtils.SOUND_DIALBOX_SELEC.play();
		}

		if(game.getInput().isKeySpaceJustPressed()){
			GdxUtils.SOUND_DIALBOX_ACTIVATE.play();
			if(mode==0){
				activate = false;
			}else{
				Gdx.app.exit();
			}
		}
	}

	public void initGameOver(OneRoom game){
		this.newScore = game.getHud().getKills();
		strNewScore = ""+newScore;
		while(strNewScore.length()<3){
			strNewScore = "0"+strNewScore;
		}
		if(newScore>bestScore){
			bestScore=newScore;
			strBestScore = strNewScore;
			strNewScore += " (new record !)";
		}
		if(GdxUtils.MUSIC_01.isPlaying()){GdxUtils.MUSIC_01.stop();}
		if(GdxUtils.MUSIC_02.isPlaying()){GdxUtils.MUSIC_02.stop();}
		this.gameOverOpacity=0f;
		cptGameOver=0;
		GdxUtils.SOUND_GAMEOVER.play();
	}

	public boolean isActive(){
		return activate;
	}
}
